function [] = RAMHarvestContour(L,eF,allMSY,firstPt,theta)
%plot bifurcation along L*ln(MSY) on x-axis
scrsz = get(0,'ScreenSize');
figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3) scrsz(4)/2.5]);
subplot(1,3,1)
colormap hsv
indicesBelowMSY=find(reshape(firstPt,1,1,[])<0);
indicesAboveMSY=find(reshape(firstPt,1,1,[])>=0);
%scatter3(L2,log(allMSY*1000),eF,[],reshape(log(allMSY*1000),[],1),'filled','jitter','on')
%scatter3(L2,log(allMSY*1000),eF,'k','filled','jitter','on')
scatter(L(indicesAboveMSY).*log(allMSY(indicesAboveMSY)*1000),eF(indicesAboveMSY),16,[0.5 0 0],'o','filled')
hold on
scatter(L(indicesBelowMSY).*log(allMSY(indicesBelowMSY)*1000),eF(indicesBelowMSY),16,[0 0 0.5],'o')
xlim([6 45])
ylim([-6.5 4])
grid off
hold on
%eL=1;
LlnMSYrange=[5:0.5:45];
Fsols=[];
for i=1:length(LlnMSYrange)
    LMSYlevel=LlnMSYrange(i);
    Fsol=[0; log(1+(1-1/((1/theta)*LMSYlevel))^0.5)/log(2); log(1-(1-1/((1/theta)*LMSYlevel))^0.5)/log(2)];
    Fsol(imag(Fsol)~=0)=-100;
    Fsol=sort(Fsol,'descend');
    Fsol(Fsol==-100)=NaN;
    Fsols(1:length(Fsol),i)=Fsol;
end
plot1=plot(LlnMSYrange,Fsols','Color','k','LineWidth',2);
plot1(2).LineStyle='--';
ylabel 'log_2(F/F_M_S_Y)'
xlabel '\gammaln(MSY[kg])'
%legend 'F_{init}>F_{MSY}' 'F_{init}<F_{MSY}'
legend off
%title('fitted model')

xIntSteps=10; %x-axis rolling window width
yHistSteps=21; %y-axis histogram bins
yEdges=[-6.5:10/(yHistSteps-1):4];
XYcontourLo=nan(yHistSteps+1,45);
XYcontourUp=nan(yHistSteps+1,45);
allLlnMSY=L.*log(allMSY*1000);
for LlnMSYpt=1:45 %x-axis position (gamma.*ln(MSY[kg]))
    LowerX=max(LlnMSYpt-xIntSteps/2,0);
    UpperX=min(LlnMSYpt+xIntSteps/2,45);
    SelectPtsLo=find(reshape(allLlnMSY>=LowerX,[],1) .* reshape(allLlnMSY<UpperX,[],1) .* (firstPt<0)); %points in window with initial F<Fmsy
    SelectPtsUp=find(reshape(allLlnMSY>=LowerX,[],1) .* reshape(allLlnMSY<UpperX,[],1) .* (firstPt>=0)); %points in window with initial F>=Fmsy
%     XYcontourLo(:,LlnMSYpt)=histcounts(eF(SelectPtsLo),yEdges)/length(eF(SelectPtsLo));
%     XYcontourUp(:,LlnMSYpt)=histcounts(eF(SelectPtsUp),yEdges)/length(eF(SelectPtsUp));
    if ~isempty(SelectPtsLo)
        LoKest=ksdensity(reshape(eF(SelectPtsLo),[],1),yEdges);
    else
        LoKest=NaN(length(yEdges),1);
    end
    if ~isempty(SelectPtsUp)
        UpKest=ksdensity(reshape(eF(SelectPtsUp),[],1),yEdges);
    else
        UpKest=NaN(length(yEdges),1);
    end
    XYcontourLo(:,LlnMSYpt)=LoKest;
    XYcontourUp(:,LlnMSYpt)=UpKest;
end

%figure('Color',[1 1 1]);
ax1=subplot(1,3,2);
bluemap=flipud(gray(64));
bluemap(:,3)=1;
colormap(ax1,bluemap)
%imagesc(XYcontourLo,'AlphaData',1);
contourf(XYcontourLo,'LineStyle','none','LevelStep',0.1);
set(gca,'YDir','normal')
xticks([])
yticks([])
% yticks([1:yHistSteps])
% yticklabels(yEdges)
caxis([0 1])
xlim([6 45])
%colorbar

ax2=subplot(1,3,3);
redmap=flipud(gray(64));
redmap(:,1)=1;
colormap(ax2,redmap)
%imagesc(XYcontourUp,'AlphaData',1);
contourf(XYcontourUp,'LineStyle','none','LevelStep',0.1);
set(gca,'YDir','normal')
xticks([])
yticks([])
% yticks([1:yHistSteps])
% yticklabels(yEdges)
caxis([0 1])
xlim([6 45])
%colorbar