
%Edward Tekwa 2/19/17, 3/23/17, 5/24/17
%run maximum likelihood procedure to fit harvest rate evolution model (with
%imperfection) to RAM database fisheries' changes in harvest rates
%first, run RAManalysis_boot_pooled5_minTrans.m, or load:
%load ('RAManalysis fit 100000 F permutations N model 217pts regional.mat') %this contains both original data for analysis and final analysis outputs for reference
%load ('RAManalysis fit 100000 permutations model 217pts regional and gear.mat')

options = optimset('MaxFunEvals', 2000,'Display','off','TolFun',1e-4,'TolX',1e-4); %for fminsearch

%fit model to harvest rates (1), changes in harvest rate (2), or both (3)
fitType=1;

%fit to raw data (1), F<2 (2), log2(F) (3), or log2(F)<1 (4)
dataType=3;
%limit fitting data to F<2
% avgAllPt2=avgAllPt(:,:,avgAllPt(:,1,:)<2);
% avgAllChange2=avgAllChange(:,:,avgAllPt(:,1,:)<2);
TimeGap=1; %gap between initial time point and time points used to compute average F (the dependent variable)

avgAllChange2=avgAllChange;
%avgAllChange2=reshape((diff(XY_Yr(:,1,:))),1,1,[]);
avgAllChange2=avgAllChange2(~isnan(avgAllChange2(1,1,:)));
eFchange=avgAllChange2(:,1,:);
firstPt=[];
avgAllPt2=[];
TimeSeriesLength=[];
harvestYr2=[];
biomassYr2=[];
Fishery_Yr2={};
j=1;
for i=1:length(XY_Yr)
    %posFirstPt=min(find(~isnan(XY_Yr(:,1,i)))); %first known time point of current fishery
    posFirstPt=min(find(~isnan(XY_Yr(:,1,i)).*XY_Yr(:,1,i)>0));
    posLastPt=max(find(~isnan(XY_Yr(:,1,i)).*XY_Yr(:,1,i)>0));
    if nanmean(XY_Yr(posFirstPt:end,5,i))>0
        firstPt(j,:)=XY_Yr(posFirstPt,1,i);
        %[acf,lags,bounds]=autocorr(XY_Yr(posFirstPt:min([length(XY_Yr(:,1,i)),min(find(isnan(XY_Yr(posFirstPt:end,1,i))))-1]),1,i));
        TimeSeriesLength(j)=posLastPt-posFirstPt+1;
        %AutoLag(j)=max(find(acf>=bounds(1) | acf<=bounds(2))); %# lag years that are significantly autocorrelated
        avgAllPt2(:,:,j)=nanmean(XY_Yr(min(posFirstPt+TimeGap,posLastPt):posLastPt,:,i)); %take average removing first TimeGap (5) time points
        harvestYr2(j,:)=harvestYr(i,:);
        biomassYr2(j,:)=biomassYr(i,:);
        Fishery_Yr2{j,1}=Fishery_Yr{i,1};
        Fishery_Yr2{j,2}=Fishery_Yr{i,2};
        Fishery_Yr2{j,3}=posFirstPt+YrStart-1; %initial year +1960
        Fishery_Yr2{j,4}=posLastPt+YrStart-1; %final year +1960
        j=j+1;
    end
end
%avgAllPt2=avgAllPt; %use averages of each fishery
%avgAllPt2=reshape(XY(:,1:2)',1,2,[]); %use all points
validPos=avgAllPt2(1,1,:)~=0 & log(avgAllPt2(1,5,:))>0 & reshape(TimeSeriesLength,1,1,[])>TimeGap+2; %find fisheries where harvest rate is not zero, ln(MSY)>0, and time series length is long enough for the meanF to contain 3 pts
avgAllPt2=avgAllPt2(1,:,validPos);
harvestYr2=harvestYr2(validPos,:);
biomassYr2=biomassYr2(validPos,:);
firstPt=firstPt(validPos,1);
Fishery_Yr2=Fishery_Yr2(validPos,:);
if dataType==3
    firstPt=log2(firstPt);
    avgAllPt2(:,1,:)=log2(avgAllPt2(:,1,:)); %use log2(F)
end
harvestYr2nonzero=harvestYr2;
harvestYr2nonzero(harvestYr2nonzero==0)=NaN;
L=avgAllPt2(:,2,:);
eF=avgAllPt2(:,1,:);
allMSY=avgAllPt2(:,5,:);
allr=avgAllPt2(:,6,:);

%analyze relationship between F/Fmsy (X_t) and B/Bmsy (Y_t+1) for each base
%year
KobeCoeff=[]; %intercept & slope of linear regression of S/Smsy on F/Fmsy (row 1&2, columns are years)
KobeCoeffSE=[]; %intercept & slope standard errors
KobeP=[]; %intercept & slope p-values
KobeR2=[]; %R^2 of regression
KobePts=[]; %sample pts per year
yrLag=0;
for yr=1:size(harvestYr2,2)-yrLag
    KobeFit=fitlm(min(harvestYr2(:,yr),2,'includenan'),biomassYr2(:,yr+yrLag));
    KobeCoeff(:,yr)=KobeFit.Coefficients.Estimate; %intercept & slope of linear regression of S/Smsy on F/Fmsy (row 1&2, columns are years)
    KobeCoeffSE(:,yr)=KobeFit.Coefficients.SE; %intercept & slope standard errors
    KobeP(:,yr)=KobeFit.Coefficients.pValue; %intercept & slope p-values
    KobeR2(yr)=KobeFit.Rsquared.Ordinary; %R^2 of regression
    KobePts(yr)=KobeFit.NumObservations; %sample pts per year
    if yr==33
        figure; plot(KobeFit);
    end
end
meanKobeCoeffs=mean(KobeCoeff,2)
stdKobeInt=std(KobeCoeff(1,:))
stdKobeSlope=std(KobeCoeff(2,:))
meanKobeR2=mean(KobeR2)
stdKobeR2=std(KobeR2)

figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3)/2.5 scrsz(4)/2.5]);
%subplot(1,2,1)
hYrScatter=gscatter(ones(217,1)*[1:49],log2(harvestYr2nonzero));
set(hYrScatter,'MarkerSize',4,'Color','k');
hold on
plot(nanmean(log2(harvestYr2nonzero)),'k','LineWidth',2)
plot(prctile(log2(harvestYr2nonzero),97.5),'k','LineWidth',1)
plot(prctile(log2(harvestYr2nonzero),2.5),'k','LineWidth',1)
plot(prctile(log2(harvestYr2nonzero),75),'k','LineWidth',1)
plot(prctile(log2(harvestYr2nonzero),25),'k','LineWidth',1)
ylabel 'log_2(F/F_{MSY})'
xlabel 'year'
xticks([1:10:length(KobeCoeff)])
xticklabels([YrStart:10:YrEnd])
yyaxis right
plot(sum(log2(harvestYr2nonzero)>0)./sum(~isnan(harvestYr2nonzero)),'LineWidth',2)
ylabel 'fraction overfished'

figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3)/2.5 scrsz(4)/2.5]);
%subplot(1,2,2)
bar(KobeCoeff(1,:),'w')
hold on
IntMean=refline(0,meanKobeCoeffs(1));
set(IntMean,'Color','k','LineWidth',2)
bar(KobeCoeff(2,:),'FaceColor',[0.9 0.9 0.9])
SlopeMean=refline(0,meanKobeCoeffs(2));
set(SlopeMean,'Color','k','LineWidth',2)
ylabel 'coefficient estimates'
yyaxis right
plot(KobeR2,'LineWidth',2)
ylim([-.171 .4])
ylabel 'R^2'
xlabel 'year'
xticks([1:10:length(KobeCoeff)])
xticklabels([YrStart:10:YrEnd])

% compute coefficient of variations for cost/benefit ratios between
% countries and between gear types
% country CV:
%Lcountries=unique(round(L2,10));
mean(L2);
LCV=var(L2)/mean(L2)
%Gear contains cost/benefit ratios for different gear types (Lam 11 table
% 5)
GearLsamples=repelem(Gear(:,1), Gear(:,2)); %weigh lambda of each gear type by number of records in Lam 11
mean(GearLsamples);
LgearCV=var(GearLsamples)/mean(GearLsamples)

%**** reset data to autocorrelation-corrected (from RAManalysis_timelags)
firstPt=firstAutoPt; %use log2(F)
avgAllPt2=avgAllAutoPt2; %use log2(F)
L=autoL;
eF=autoF;
allMSY=autoMSY;
%****
Pos_no_outliers=[];
%remove outliers in Fishery_Yr2 (or Fishery_Yr): 158(194)=orange roughy, 187(224)=Patagonian toothfish
%Pos_no_outliers(1,1,:)=[1:157,159:186,188:length(Fishery_Yr2)];
% Pos_no_outliers(1,1,:)=[1:157,159:length(Fishery_Yr2)]; %exclude orange roughy
% %Pos_no_outliers(1,1,:)=[1:186,188:length(Fishery_Yr2)]; %exclude
% %Patagonian toothfish
% Fishery_Yr2=Fishery_Yr2(Pos_no_outliers,:);
% firstPt=firstPt(Pos_no_outliers); %use log2(F)
% avgAllPt2=avgAllPt2(:,:,Pos_no_outliers); %use log2(F)
% L=L(:,:,Pos_no_outliers);
% eF=eF(:,:,Pos_no_outliers);
% allMSY=allMSY(:,:,Pos_no_outliers);

%plot harvest rate F as a function of cost/benefit and MSY
%obtain linear regression
x1=reshape(L,[],1)/std(L);
%x2=reshape(log(allMSY+1),[],1);
x2=reshape(log(allMSY*1000),[],1)/std(log(allMSY*1000));
x3=reshape(firstPt>=0,[],1)/std(firstPt>0); %binary: 1 if F_init >F_msy, 0 otherwise
%X=[ones(size(x1)) x1 x2 x1.*x2];
%X=[ones(size(x1)) x1 x2];
%X=[ones(size(x1)) x1 x2 x3];
X=[ones(size(x3)) x3]; %only use binary initial conditions (with intercept and slope)
[b, bint, r, rint, linstats]=regress(reshape(eF,[],1),X);
InitCoeffs=b %intercept, I/V coefficient, MSY coefficient, init F coefficient
InitIntervals=bint
linstats %R^2, F, p, err var

X=[ones(size(x2)) x2]; %only use gammaLn(MSY)
[bGL, bintGL, rGL, rintGL, linstatsGL]=regress(reshape(eF,[],1),X);
LinRegressCoeffsGL=bGL %intercept, I/V coefficient, MSY coefficient, init F coefficient
LinRegressIntervalsGL=bintGL
linstatsGL %R^2, F, p, err var

figure('Color', [1 1 1]);
scatter(firstPt>0,eF);
hold on
refline(1,0);
refhor=refline(0,0);
set(refhor,'Color','k');
plot([0 0],ylim,'k')
xlabel 'initial log_2(F/F_{MSY})'
ylabel 'mean log_2(F/F_{MSY}) (excludes first year)'

scrsz = get(0,'ScreenSize');
figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3) scrsz(4)/2.5]);
subplot(1,3,3)
histogram(avgAllPt2(:,1,:),'FaceColor',[0.9 0.9 0.9]);
ylabel 'frequency'
xlabel 'harvest rate log_2(F/F_{MSY})'
subplot(1,3,2)
histogram(log(allMSY*1000),'FaceColor',[0.9 0.9 0.9]);
ylabel 'frequency'
xlabel 'fish stock ln(MSY[kg]))'
subplot(1,3,1)
histogram(avgAllPt2(:,2,:),'FaceColor',[0.9 0.9 0.9]);
ylabel 'frequency'
xlabel 'cost/benefit \gamma'

%plot total MSY in each MSY bin across the world
figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3)/3 scrsz(4)/2.5]);
%MSYhist=histogram((allMSY),'FaceColor',[0.9 0.9 0.9]);
numBins=10;
binMSY=[];
MSYvector=reshape(allMSY,[],1);
%lnMSYvector=reshape(log(allMSY*1000),[],1);
lnMSYvector=reshape(allMSY,[],1);
minlnMSY=floor(min(lnMSYvector));
maxlnMSY=ceil(max(lnMSYvector));
lnMSYbins=[minlnMSY:(maxlnMSY-minlnMSY)/(numBins-1):maxlnMSY];
for i=1:length(lnMSYbins)-1
   binMSY(i)=(sum(MSYvector(find(lnMSYvector>=lnMSYbins(i) & lnMSYvector<lnMSYbins(i+1)))));
end
bar(binMSY);
xticks([1:length(lnMSYbins)-1])
xticklabels(lnMSYbins)
ylabel 'ln(total MSY in bin)'
xlabel 'ln(MSY[kg]))'

%freeparstart=[0.0222,0.01,3.9543,1]; %[E N R b]=[imperfection term, evol rate, r*Smsy, beta(risk aversion)]
%freeparstart=[2.61,1,4.9307,1];
%freeparstart=[2.7897    1.0000    4.5784    1.0000]; %fval=9.9474
%freeparstart=[0.00435070286453954,1,2.75676703571226,1]; %fval=20.5125 (fit to harvest rates<2, weight exp=0)
%freeparstart=[0.0175386828353086,1,2.64315077123759,1]; %fval=0.8214
%freeparstart=[0.370643758745823,0]; %delta, imperfection
%freeparstart=[0.0757902804248014,0];
%freeparstart=[0.0757903737291numPts,1000];
freeparstart=[10,1000]; %N, MSY unit scaling [/tonnes]
freeparmin=[0 1000];
freeparmax=[100 1000]; %[1000 1000]
% freeparstart=[1,100];
% freeparmin=[1 0];
% freeparmax=[1 1e6]; %[100 1000]
freeparmin2=[0 0];
freeparmax2=[100 1e6];

fval=100000;
eF=avgAllPt2(:,1,:); %mean harvest rate over years
eF2=avgAllPt2(:,1,:);
L=avgAllPt2(:,2,:); %mean (cost+subsidy)/landing value over years
L2=avgAllPt2(:,2,:);
%V=avgAllPt2(:,3,:); %mean landing value/landings over years
Imin=min(L);
Imax=max(L);
%construct weight of each data point as the inverse of number of points in
%its F and L window
WeightExp=0; %exponent determines relative weight to each datapoint (0=equal for all, 1=inverse to # nearby datapoints (weigh up rare points), -1=proportional to # nearby datapoints (weigh up abundant points), etc.)
PtWeight=ones(1,length(L));
maxPtWeight_to_total=max(PtWeight)/sum(PtWeight)

PtWeight2=ones(1,length(avgAllChange2));
maxPtWeight_to_total2=max(PtWeight2)/sum(PtWeight2)

%calculate null model statistics
MeanChange=nanmean(avgAllChange2(:,1,:))
%WeightedMeanChange=nansum(PtWeight2.*reshape(avgAllChange2(:,1,:),1,[]))/sum(PtWeight)
STotDirNoWeightMean=nansum(reshape((nanmean(avgAllChange2(:,1,:)).*avgAllChange2(:,1,:))<=0,1,[])) %total weighted sum of squares (with weighted directional differences of null model) 
%STotDirMean=nansum(PtWeight2.*reshape((nanmean(avgAllChange2(:,1,:)).*avgAllChange2(:,1,:))<=0,1,[])) %total weighted sum of squares (with weighted directional differences of null model) 
STotDirMean=10000;
%STotDir2Mean=nansum(PtWeight2.*reshape((WeightedMeanChange.*avgAllChange2(:,1,:))<=0,1,[])) %total weighted sum of squares (with weighted directional differences of null model) 
%STotMag=nansum(PtWeight2.*reshape(((nanmean(avgAllChange2(:,1,:))-avgAllChange2(:,1,:)).^2),1,[])) %total weighted sum of squares (with weighted magnitude differences of null model)
%STotMag2=nansum(PtWeight2.*reshape(((WeightedMeanChange-avgAllChange2(:,1,:)).^2),1,[])) %total weighted sum of squares (with weighted magnitude differences of null model)
STotMag=10000;
STotmeans=nansum(reshape((nanmean(eF)-eF).^2,1,[])) %total weighted sum of squares
%STotmeans=sum(~isnan(eF))*nanvar(eF); %total sum of squares
%LLweightedmeans=sum(PtWeight.*LLmeans);
Mean=nanmean(eF)
SD=std(eF)
WeightedMean=nansum(PtWeight.*reshape(avgAllPt2(:,1,:),1,[]))/sum(PtWeight)
SWeightedmeans=nansum(PtWeight.*reshape((WeightedMean-eF).^2,1,[])) %total weighted sum of squares
LLInit=nansum(reshape((firstPt(:,1)-eF(:)).^2,1,[])) %total weighted sum of squares of initial condition model
InitCondR2=1-LLInit/SWeightedmeans

%evaluate effort model (cost=IF instead of IFS):
disp('fitting effort model by estimating both N and MSY unit:');
freeparminE=[0 0];
freeparmaxE=[100 1e6];
[ParamEstsE,fvalE,exitflag,output] = fminsearchbnd(@(params) effortModel(allr,L,eF,allMSY,params),freeparstart,freeparminE,freeparmaxE,options);
%SSEffortModel=effortModel(allr,L,eF,allMSY,params); %get sum of squares of effort model
R2EffortModel=1-fvalE/SWeightedmeans;
disp(['R^2=' num2str(R2EffortModel) ', LL=' num2str(fvalE) ', N=' num2str(ParamEstsE(1)) ', MSY unit [1000kg/#]=' num2str(ParamEstsE(2))]);

%evaluate constant price and effort-based cost model
disp('constant price and effort model (no free parameter):');
% [ParamEstsC,fvalC,exitflag,output] = fminsearchbnd(@(param) ConstPriceEffortModel(allr,L,eF,allMSY,param),1,0,1e6,options);
%ConstPriceEffortModel(allr,L,eF,allMSY,param);
fvalC=ConstPriceEffortModel(L,eF);
R2CModel=1-fvalC/SWeightedmeans;
disp(['R^2=' num2str(R2CModel) ', LL=' num2str(fvalC)]);


%null model with two constant lines for the two initial condition groups
STotBelowMean=nansum(reshape((nanmean(eF(firstPt<0))-eF(firstPt<0)).^2,1,[])); %total weighted sum of squares
STotAboveMean=nansum(reshape((nanmean(eF(firstPt>=0))-eF(firstPt>=0)).^2,1,[])); %total weighted sum of squares
AboveBelowMeansR2=1-(STotBelowMean+STotAboveMean)/SWeightedmeans

%evaluate separate line model (instead of using means of F and dF, use
%constant models that fit F and dF separately, for current weight
%[ParamEstsdF,fvaldF,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML2(avgAllPt2,avgAllChange2,PtWeight2,Window,Fwin,params),freeparstart2,freeparmin0,freeparmax0,options);
STotDir=10000;

global prevLLdF
global prevLLF
prevLLdF=STotDir;
prevLLF=SWeightedmeans;

%evaluate null model for current weight
%[ParamEstsNull,fvalNull,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML2_fitF_dF(avgAllPt2,avgAllPt2,avgAllChange2,PtWeight2,PtWeight2,Window,Fwin,1,params),freeparstart0,freeparmin0,freeparmax0,options);
%STotDirNull=RAManalysis_ML2(avgAllPt2,avgAllChange2,PtWeight2,Window,Fwin,ParamEstsNull)
%fval=(LLdF/prevLLdF)+(LLF/prevLLF), so LLF=(fval-(LLdF/prevLLdF))*prevLLF:
%STotmeansNull=RAManalysis_ML_fitF(avgAllPt2,PtWeight2,Window,Fwin,dataType,ParamEstsNull);
fvalNull=10000;
STotDirNull=10000;
STotmeansNull=(fvalNull-(STotDirNull/prevLLdF))*prevLLF %this is faster
%F0=1-1/ParamEstsNull(1)+((ParamEstsNull(1)^2+1)^(1/2))/ParamEstsNull(1); %null model's F expectation
if fitType==1
    STotmeansNull=SWeightedmeans; %if fitting only to F
    F0=WeightedMean;
elseif fitType==2
    STotDirNull=STotDir; %if fitting only to dF
end
F0

% disp('exploring parameter space:');
% numSamples=50;
% LLmap=ones(numSamples+1,numSamples+1)*NaN;
% for i=1:numSamples+1
%     for j=1:numSamples+1
%         freeparstartN=[freeparmin(1)+(freeparmax(1)-freeparmin(1))*(i-1)/numSamples freeparmin(2)+(freeparmax(2)-freeparmin(2))*(j-1)/numSamples]; %[E N R b]=[imperfection term, evol rate, r*Smsy, beta(risk aversion)]
%         %fvalN=RAManalysis_ML_fitF(avgAllPt2,firstPt,PtWeight,Window,Fwin,F0,dataType,freeparstartN);
%         fvalN =RAManalysis_ML_fitF_msy(avgAllPt2,firstPt,freeparstartN);
%         LLmap(i,j)=1-fvalN/STotmeansNull;
%     end
% end
% figure;
% LLmap2=LLmap;
% LLmap2(LLmap<0)=0;
% contourf(LLmap2);
% xlabel '\eta';
% ylabel 'MSY unit [1000kg/#]';
% title 'R^2';
% %caxis([min(LLmap(:)) min(LLmap(:))+200]);
% xticks([1:numSamples/10:numSamples+1]);
% xticklabels([freeparmin(1):(freeparmax(1)-freeparmin(1))/10:freeparmax(1)]);
% yticks([1:numSamples/10:numSamples+1]);
% yticklabels([freeparmin(2):(freeparmax(2)-freeparmin(2))/10:freeparmax(2)]);

figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3)*2.2/3 scrsz(4)/2.5]);
%fit eta with different MSY units:
etasR2=[];
etas=[];
for i=1:100
    freeparminN=[0 10^((i-1)/10-1)]; %start at 10000kg
    freeparmaxN=[100 10^((i-1)/10-1)];
    [ParamEstsN,fvalN,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy(avgAllPt2,firstPt,params),freeparstart,freeparminN,freeparmaxN,options);
    etasR2(i)=1-fvalN/STotmeansNull;
    etas(i)=ParamEstsN(1);
end
subplot(1,2,1)
yyaxis left
plot(etasR2,'LineWidth',2)
ylabel 'R^2'
yyaxis right
plot(etas,'LineWidth',2)
ylabel 'N'
title ('model R^2 and N estimate at various MSY units','FontWeight','normal')
xticks([1:10:100])
xticklabels(100000./(10.^([1:1:10])))
xlabel 'MSY unit in kg'

%evaluate fit of different eta values at MSY unit=[kg]
MSYsR2=[];
for i=60:160
    freeparstartN=[i/10 1000]; %start at 10000kg
    fvalN =RAManalysis_ML_fitF_msy(avgAllPt2,firstPt,freeparstartN);
    MSYsR2(i)=1-fvalN/STotmeansNull;
end
subplot(1,2,2)
plot(MSYsR2,'k','LineWidth',2)
xticks([60:20:160])
xticklabels([60:20:160]/10)
xlim([60 160])
xlabel 'N'
ylabel 'R^2'
title ('R^2 of model with various N values and MSY unit=[kg]','FontWeight','normal')

disp('fitting full model by estimating both N and \MSY unit:');
[ParamEstsN,fvalN,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy(avgAllPt2,firstPt,params),freeparstartN,freeparmin2,freeparmax2,options);
R2N=1-fvalN/STotmeansNull;
disp([num2str(i) ',R^2=' num2str(R2N) ', LL=' num2str(fvalN) ', N=' num2str(ParamEstsN(1)) ', MSY unit [1000kg/#]=' num2str(ParamEstsN(2))]);


disp('fitting full model by estimating N only:');
for i=1:50
    prevLLdF=STotDir;
    prevLLF=SWeightedmeans;
    freeparstartN=freeparmin+(freeparmax-freeparmin).*rand(1,2); %[E N R b]=[imperfection term, evol rate, r*Smsy, beta(risk aversion)]
    if i==1
        freeparstartN=freeparstart;
    end
    %to fit model to harvest rates, use all data:
    [ParamEstsN,fvalN,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy(avgAllPt2,firstPt,params),freeparstartN,freeparmin,freeparmax,options);
     R2N=1-fvalN/STotmeansNull;
    disp([num2str(i) ',R^2=' num2str(R2N) ', LL=' num2str(fvalN) ', N=' num2str(ParamEstsN(1)) ', MSY unit [1000kg/#]=' num2str(ParamEstsN(2))]);
    if fvalN<fval
        fval=fvalN;
        freeparstart=freeparstartN;
        ParamEsts=ParamEstsN;
    end
end
freeparstart
ParamEsts %=freeparstart
fval

freeparstart=ParamEsts;
RAMHarvestContour(L,eF,allMSY,firstPt,N); %plot model with data and empirical distributions

%plot residuals as function of gamma*ln(MSY)
[LL,LLmeans,Fsols] = RAManalysis_ML_fitF_msy_Yvalues(avgAllPt2,firstPt,ParamEsts); %obtain residuals for all points
figure; scatter(reshape(log(allMSY*1000).*L,1,[]),LLmeans);
xlabel 'gamma*ln(MSY)'
ylabel 'residual^2'

%evaluate model
%LL=RAManalysis_ML2(avgAllPt2,avgAllChange2,PtWeight2,Window,Fwin,ParamEsts);
LLweightedmeans=fval;%R2ChangeModel_direction=1-LL/STotDir
%R2ChangeModel_direction_vsNull=1-LL/STotDirNull
%R2means=1-LLweightedmeans/SWeightedmeans
R2means_vsNull=1-LLweightedmeans/STotmeansNull
%R2tot
diffR2_vsNull=R2means_vsNull-AboveBelowMeansR2
percent_PathDep=sum((L.*log(allMSY*1000)>ParamEsts(1)))/length(avgAllPt2)

%evaluate model with N=10.3
fval10_3=RAManalysis_ML_fitF_msy(avgAllPt2,firstPt,[10.3 1000]);
R2_10_3=1-fval10_3/STotmeansNull

%fit model variant with only lower equilibrium (economic optimum model)
[ParamEstsN,fvalN,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy_lowerOnly(avgAllPt2,firstPt,params),freeparstartN,freeparmin,freeparmax,options);
R2N=1-fvalN/STotmeansNull;
disp(['lower solution only: R^2=' num2str(R2N) ', LL=' num2str(fvalN) ', N=' num2str(ParamEstsN(1)) ', MSY unit [1000kg/#]=' num2str(ParamEstsN(2))]);

%fit model variant with only upper equilibrium
[ParamEstsN,fvalN,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy_upperOnly(avgAllPt2,firstPt,params),freeparstartN,freeparmin,freeparmax,options);
R2N=1-fvalN/STotmeansNull;
disp(['upper solution only: R^2=' num2str(R2N) ', LL=' num2str(fvalN) ', N=' num2str(ParamEstsN(1)) ', MSY unit [1000kg/#]=' num2str(ParamEstsN(2))]);


%plot data and model predictions at log10(MSY+1)=[1:6], coded with marker
%color
figure; scatter3(L,log(allMSY*1000),eF,[],reshape(log(allMSY*1000),[],1),'jitter','on')
xlabel 'total cost/total landing value (\gamma)'
ylabel 'log(MSY[kg])'
zlabel 'log2(F/F_{MSY})'


%randomize data, reapply weighting according to original rolling windows,
%and assess new model fit to the randomized data (R^2 distribution)
R2RandDist=[];
R2MagRandDist=[];
R2FRandDist=[];
R2RandDist_vsNull=[];
R2FRandDist_vsNull=[];
RDist=[];
EDist=[];
R2FRegRandDist_vsNull=[];
RRegDist=[];
ERegDist=[];
AboveBelowMeansBootR2=[];
diffR2=[]; 
[RegionOrder,RegionIndex,RegionAll]= unique(join(string(Fishery_Yr2_EW(:,2:3)))); %get regional ids for all fisheries
display(['Model R^2=' num2str(R2means_vsNull) ', diffR^2=' num2str(diffR2_vsNull)]);
display('starting randomization:');
numRand=100000;
for i=1:numRand
%     randL=datasample(L2,length(L2)); %randomize I/V data
%     randFchange=datasample(eFchange,length(eFchange)); %resample with replacement mean harvest rate changes
%     randF=datasample(eF,length(eF)); %randomized harvest rates
    randL=L2; %original I/V data
    randFchange=eFchange(randperm(size(eFchange,3))); %randomized mean harvest rate changes
    randFOrder=randperm(size(eF,3));
    randF=eF(randFOrder); %randomized harvest rates
    %randFirstPt=firstPt(randperm(size(firstPt,1))); %randomized first harvest rate of each fishery
    randFirstPt=firstPt(randFOrder); %preserve initial condition with fishery
    %randMSY=allMSY(randperm(size(allMSY,3))); %randomize stock MSY
    randMSY=allMSY; %preserve MSY with I/V
    % test 2: permute cost/benefit (L2) by country rather than by fishery
    % (assuming all fisheries in each country are correlated) - use
    % original eF and firstPt, and MSY permuted by fishery
    randRegionOrder=randperm(length(RegionTable));
    randRegionTable=RegionTable(randRegionOrder,1);
    randRegionL=randRegionTable(RegionAll);
    randMSY2=allMSY(randFOrder);
    PtWeightBoot=ones(1,length(randL));
    RandSTotDir2=10000;
    WeightedRandMean=nansum(PtWeightBoot.*reshape(randF,1,[]))/sum(PtWeightBoot);
    FBoot0=WeightedRandMean;
    RandFTot=nansum(PtWeightBoot.*reshape((WeightedRandMean-randF).^2,1,[])); %total weighted sum of squares
    prevLLdF=RandSTotDir2; %update estimated variances to weigh objectives in subsequent fits within this boot
    prevLLF=RandFTot;
    STotDirBootNull=RandSTotDir2;
    STotmeansBootNull=RandFTot;

    %fit full model to randomized data
    if fitType==1
        %fit to data with cost/benefit randomized by fisheries
        [ParamEstsBoot,fvalBoot,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy([randF randL zeros(1,1,length(randF)) zeros(1,1,length(randF)) randMSY],randFirstPt,params),freeparstart,freeparmin,freeparmax,options);
        %fit to data with cost/benefit randomized by (21) regions
        [ParamEstsBootReg,fvalBootReg,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy([eF reshape(randRegionL,1,1,[]) zeros(1,1,length(randF)) zeros(1,1,length(randF)) randMSY2],randFirstPt,params),freeparstart,freeparmin,freeparmax,options);
        for j=0:0 %extra checks: try random inital guesses
            freeparstartN=freeparmin+(freeparmax-freeparmin).*rand(1,2); %random initial guess
            [ParamEstsBootN,fvalBootN,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy([randF randL zeros(1,1,length(randF)) zeros(1,1,length(randF)) randMSY],randFirstPt,params),freeparstartN,freeparmin,freeparmax,options);
            if fvalBootN<fvalBoot
                fvalBoot=fvalBootN;
                ParamEstsBoot=ParamEstsBootN;
            end
        end
        %randLL=Inf;
        randFLL=fvalBoot;
    elseif fitType==2
        [ParamEstsBoot,fvalBoot,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML2([randF randL],randFchange,PtWeightBoot,Window,Fwin,params),freeparstart,freeparmin,freeparmax,options);
        randLL=fvalBoot;
        randFLL=RAManalysis_ML_fitF([randF randL],randFirstPt,PtWeightBoot,Window,Fwin,FBoot0,dataType,ParamEstsBoot);   
    else
        [ParamEstsBoot,fvalBoot,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML2_fitF_dF([randF randL],[randF randL],randFchange,PtWeightBoot,PtWeightBoot,Window,Fwin,FBoot0,params),freeparstart,freeparmin,freeparmax,options);
        randLL=RAManalysis_ML2([randF randL],randFchange,PtWeightBoot,Window,Fwin,ParamEstsBoot);
        randFLL=(fvalBoot-(randLL/prevLLdF))*prevLLF; %this is faster
end
    R2RandDist(i)=1-randLL/RandSTotDir2;
    R2RandDist_vsNull(i)=1-randLL/STotDirBootNull;
    R2FRandDist(i)=1-randFLL/RandFTot;
    R2FRandDist_vsNull(i)=1-randFLL/STotmeansBootNull;
    RDist(i)=ParamEstsBoot(1);
    EDist(i)=ParamEstsBoot(2);
    R2FRegRandDist_vsNull(i)=1-fvalBootReg/STotmeansBootNull;
    RRegDist(i)=ParamEstsBootReg(1);
    ERegDist(i)=ParamEstsBootReg(2);
   
    STotBelowMeanBoot=nansum(reshape((nanmean(randF(randFirstPt<0))-randF(randFirstPt<0)).^2,1,[])); %total weighted sum of squares
    STotAboveMeanBoot=nansum(reshape((nanmean(randF(randFirstPt>=0))-randF(randFirstPt>=0)).^2,1,[])); %total weighted sum of squares
    AboveBelowMeansBootR2(i)=1-(STotBelowMeanBoot+STotAboveMeanBoot)/STotmeansBootNull;
    diffR2(i)=R2FRandDist_vsNull(i)-AboveBelowMeansBootR2(i);
    pTemp=sum(R2FRandDist_vsNull>=R2means_vsNull)/length(R2RandDist);
    pTemp2=sum(R2FRegRandDist_vsNull>=R2means_vsNull)/length(R2RandDist);
    display([num2str(i) ' F R^2: ' num2str(R2FRandDist_vsNull(i)) ', N=' num2str(ParamEstsBoot(1)) ' F R^2(regional): ' num2str( R2FRegRandDist_vsNull(i)) ', N(regional)=' num2str(ParamEstsBootReg(1)) ', w=' num2str(ParamEstsBoot(2)) ', p=' num2str(pTemp) ', p(regional)=' num2str(pTemp2)]);    
end
%pFModel=sum(R2FRandDist>=R2means)/length(R2RandDist)
pFModel_vsNull=sum(R2FRandDist_vsNull>=R2means_vsNull)/length(R2RandDist)
pN=2*min(sum(ParamEsts(1)>=RDist)/length(RDist),sum(ParamEsts(1)<RDist)/length(RDist)) %2-sided test
pFRegModel_vsNull=sum(R2FRegRandDist_vsNull>=R2means_vsNull)/length(R2RandDist)
pRegN=2*min(sum(ParamEsts(1)>=RRegDist)/length(RRegDist),sum(ParamEsts(1)<RRegDist)/length(RRegDist)) %2-sided test
%pE=2*min(sum(ParamEsts(2)>=EDist)/length(EDist),sum(ParamEsts(2)<EDist)/length(EDist)) %2-sided test
meanNullR2=mean(R2FRandDist_vsNull)
stdNullR2=std(R2FRandDist_vsNull)
pNullR2=sum(R2FRandDist_vsNull<=0)/length(R2RandDist)
dR2dist=R2means_vsNull-R2FRandDist_vsNull;
mean_dR2=mean(dR2dist)
std_dR2=std(dR2dist)
pFModel_vsNull_minusRand=sum(dR2dist<=0)/length(dR2dist)
%pFModel_minusInit=sum(diffR2>=diffR2_vsNull)/length(diffR2)
pFModel_minusInit=sum(R2FRandDist_vsNull>=AboveBelowMeansR2)/length(R2FRandDist_vsNull)
pInit2means=sum(AboveBelowMeansBootR2>=AboveBelowMeansR2)/length(AboveBelowMeansBootR2)



scrsz = get(0,'ScreenSize');
figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3)*2/3 scrsz(4)/2.5]);
MSYlevel=[12 14 16 18 20];

subplot(1,2,1)
his=histogram(R2FRandDist_vsNull,20,'FaceColor',[0.9 0.9 0.9]);
hold on
line([R2means_vsNull R2means_vsNull], [0 max(his.Values)],'LineWidth',2,'Color','k')
title('path-dependent model','FontWeight','normal')
xlabel(['R^2 (=' num2str(R2means_vsNull,3) ', p=' num2str(pFModel_vsNull,3) ')'])
ylabel(['frequency (' num2str(numRand) ' permutations)'])

subplot(1,2,2)
his=histogram(RDist,20,'FaceColor',[0.9 0.9 0.9]); %'BinLimits',[10 14]
%his=histogram(RDist,20,'FaceColor',[0.9 0.9 0.9]);
hold on
line([ParamEsts(1) ParamEsts(1)], [0 max(his.Values)],'LineWidth',2,'Color','k')
title('estimated N','FontWeight','normal')
xlabel(['N (=' num2str(ParamEsts(1),3) ', p=' num2str(pN,3) ')'])
ylabel(['frequency (' num2str(numRand) ' permutations)'])

figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3)/2 scrsz(4)/2]);
his=histogram(dR2dist,20,'FaceColor',[0.9 0.9 0.9]);
title({['modelled harvest rates \DeltaR^2'] ['vs. randomized data fit']},'FontWeight','normal')
xlabel(['mean \DeltaR^2 (=' num2str(mean_dR2,3) ', p=' num2str(pFModel_vsNull_minusRand,3) ')'])
ylabel(['frequency (' num2str(numRand) ' permutations)'])

N=ParamEsts(1);
V=1;

%AIC & BIC
numPts=length(avgAllPt2);
LL_CASModel=-(numPts*log(2*pi)/2+numPts*log(std(eF))+LLweightedmeans/(2*var(eF))); %LLweightedmeans is actually sum of squares
SS_StatModel=STotBelowMean+STotAboveMean; %=(1-linstats(1))*STotmeansNull;
LL_StatModel=-(numPts*log(2*pi)/2+numPts*log(std(eF))+SS_StatModel/(2*var(eF)));
[AIC_CASModel BIC_CASModel]=aicbic(LL_CASModel,1,numPts)
[AIC_StatModel BIC_StatModel]=aicbic(LL_StatModel,2,numPts)
AICc_CASModel=AIC_CASModel+2*1*(1+1)/(numPts-1-1); %AIC+0.0186
AICc_StatModel=AIC_StatModel+2*2*(2+1)/(numPts-2-1); %AIC+0.189
diff_AIC=AIC_CASModel-AIC_StatModel
diff_AICc=AICc_CASModel-AICc_StatModel
diff_BIC=BIC_CASModel-BIC_StatModel

%bootstrap for path-dependent model R^2 and parameter estimate
bootFMeans=[];
bootNs=[];
bootModelR2=[];

numBoot=2000;
for i=1:numBoot
    bootOrder=randi(size(eF,3),1,size(eF,3));
    bootF=eF(bootOrder);
    bootFirstPt=firstPt(bootOrder);
    bootL=L2(bootOrder);
    bootMSY=allMSY(bootOrder);
    
    bootMean=nanmean(bootF); %mean F
    bootSS=nansum(reshape((bootMean-bootF).^2,1,[])); %total sum of squares
 
    [ParamEstsBoot,fvalBoot,exitflag,output] = fminsearchbnd(@(params) RAManalysis_ML_fitF_msy([bootF bootL zeros(1,1,length(bootF)) zeros(1,1,length(bootF)) bootMSY],bootFirstPt,params),freeparstart,freeparmin,freeparmax,options);
    
    bootFMeans(i)=bootMean;
    bootNs(i)=ParamEstsBoot(1);
    bootModelR2(i)=1-fvalBoot/bootSS;    
    bootLL_CASModel=-(numPts*log(2*pi)/2+numPts*log(std(bootF))+fvalBoot/(2*var(bootF)));  
    display(['boot' num2str(i) ', R^2: ' num2str(bootModelR2(i)) ', N=' num2str(ParamEstsBoot(1))]);    
end

bootModelR2CI=[prctile(bootModelR2,2.5) prctile(bootModelR2,97.5)] %confidence interval for model R2
bootNs=[prctile(bootNs,2.5) prctile(bootNs,97.5)] %confidence interval for parameter N estimate

scrsz = get(0,'ScreenSize');
figure ('Color', [1 1 1],'Position',[1 scrsz(2) scrsz(3)/1.5 scrsz(4)/2.5]);

subplot(1,2,1)
his=histogram(bootFMeans,20,'FaceColor','g','FaceAlpha',0.5);
title('bootstrap estimated means of harvest rates','FontWeight','normal')
xlabel('E[log_2(F/F_{MSY})]')
ylabel(['frequency (' num2str(length(bootFMeans)) ' bootstraps)'])

subplot(1,2,2)
his=histogram(bootNs,20,'FaceColor',[0.9 0.9 0.9]);
%his=histogram(RDist,20,'FaceColor',[0.9 0.9 0.9]);
hold on
title('bootstrap estimated N','FontWeight','normal')
xlabel('N')
ylabel(['frequency (' num2str(length(bootFMeans)) ' bootstraps)'])



%plot bifurcation along L*ln(MSY) on x-axis
figure ('Color', [1 1 1]);
colormap hsv
indicesBelowMSY=find(reshape(firstPt,1,1,[])<0);
indicesAboveMSY=find(reshape(firstPt,1,1,[])>=0);
scatter(L(indicesAboveMSY).*log(allMSY(indicesAboveMSY)*1000),eF(indicesAboveMSY),'ok','filled','jitter','off')
hold on
scatter(L(indicesBelowMSY).*log(allMSY(indicesBelowMSY)*1000),eF(indicesBelowMSY),'ok','jitter','off')
text(L([indicesAboveMSY;indicesBelowMSY]).*log(allMSY([indicesAboveMSY;indicesBelowMSY])*1000),eF([indicesAboveMSY;indicesBelowMSY]), Fishery_Yr2([indicesAboveMSY;indicesBelowMSY],1), 'horizontal','left', 'vertical','bottom','FontSize',7)
% xlim([10 22.5])
ylim([-6.5 4])
grid on
hold on
%eL=1;
LlnMSYrange=[5:0.5:45];
Fsols=[];
for i=1:length(LlnMSYrange)
    LMSYlevel=LlnMSYrange(i);
    Fsol=[0; log(1+(1-1/((1/N)*LMSYlevel))^0.5)/log(2); log(1-(1-1/((1/N)*LMSYlevel))^0.5)/log(2)];
    Fsol(imag(Fsol)~=0)=-100;
    Fsol=sort(Fsol,'descend');
    Fsol(Fsol==-100)=NaN;
    Fsols(1:length(Fsol),i)=Fsol;
end
plot1=plot(LlnMSYrange,Fsols','Color','k','LineWidth',2);
plot1(2).LineStyle='--';
ylabel 'log_2(F/F_M_S_Y)'
xlabel '\gammaln(MSY[kg])'
legend 'F_{init}>F_{MSY}' 'F_{init}<F_{MSY}'
%title('fitted model')