% plot solutions to harvest rate evolution for Pella-Tomlnson growth curve

syms u(F) E F L V a r b xi R p
% E=ParamEsts(1);
% xi=ParamEsts(2);
% R=ParamEsts(3);
% b=ParamEsts(4);
E=0;
xi=1;
R=1.4116;
b=1;
V=1;
r=2;
a=1;
p=1;

%L=4.1;
Lrange=[0:2.25/200:2.25];

%case 1: logistic growth with imperfection E (also known as an additional effort-based
%cost)
E=-0.1;
Fsols=ones(3,length(Lrange))*(-100);
for i=1:length(Lrange)
    L=Lrange(i);
    u(F)=((2*F - r)*(F^2 - r*F + a/L))/(F*a*(F - r))+E;
    Fsol=vpasolve(u);
    Fsol(eval(imag(Fsol)~=0))=-100; %take out imaginary solutions
    Fsol(Fsol<0)=-100; %take out negative solutions
    Fsol(Fsol>3)=-100; %take out F>3 solutions
    Fsols(1:length(Fsol),i)=sort(Fsol,'descend');
    Fsols(Fsols==-100)=NaN;
    Fsols=sort(Fsols,'descend');
end
Fsols=log2(Fsols/(r/(p+1)));

% %make vector field
% Ffield=[0.01:0.00625:1];
% Lfield=[0.01:0.0125:2.25];
% TheorMap=zeros(length(Lfield),length(Ffield));
% for x=1:length(Lfield)
%     L=Lfield(x);
%     for y=1:length(Ffield)
%         F=Ffield(y);
%         if F<2
%             TheorMap(x,y)=E+L*(F/a + (F - r)/a) - (V*(F/a + (F - r)/a))/((F*(r - F))/a)^b;
%         else
%             TheorMap(x,y)=0;
%         end
%     end
% end
% figure; quiver(Lfield,Ffield,zeros(size(TheorMap')),TheorMap',6,'k')
% xlabel('I/V')
% ylabel('F')


fig1=figure ('Color', [1 1 1]);
%title('logistic growth')
%scatter(Lrange(i)*ones(length(Fsol),1),Fsol,'k.');
plot1=plot(Lrange,Fsols','r','LineWidth',4);
plot1(2).LineStyle='--';
hold on
%quiver(Lfield,Ffield,zeros(size(TheorMap')),TheorMap','k')
xlabel('marginal cost/benefit (I/V)')
ylabel('harvest rate (log_2(F/F_{MSY}))')
ax=gca;
ax.XTick=[0 (4*a/r^2)^b Lrange(end)];
ax.XTickLabel={'0','1/MSY^\beta',Lrange(end)};
hold on
xlim([0 2.25])
%ylim([0 3]);

% subplot(1,2,2)
% title('non-excludable resource')
% hold on
% %plot(I(1:ceil((4*a/r^2)*100/Imax)),Cp0)
% plot(I,Cp1,'k.','LineWidth',2)
% plot(I,Cp2,'k','LineWidth',2)
% xlabel('I/V')
% ylabel('F')
% %plot(I,Co1,'r','LineWidth',2)
% %ylabel('equilbrium stock level (S*)')
% ax=gca;
% ax.YTick=[0 r/2 r];
% ax.YTickLabel={'0','r/2','r'};
% ax.XTick=[0 4*a/r^2];
% ax.XTickLabel={'0','4a/r^2'};

%case 2: Pella-Tomlinson growth
p=0.5;
E=0;
Fsols=ones(3,length(Lrange))*(-100);
for i=1:length(Lrange)
    L=Lrange(i);
    u(F)=F*((r-F*p)/r)^(1/p)-a/(L*r);
    Fsol=vpasolve(u);
    Fsol=[Fsol;r/(p+1)];
    Fsol(eval(imag(Fsol)~=0))=-100; %take out imaginary solutions
    Fsol(Fsol<0)=-100; %take out negative solutions
    Fsol(Fsol>3)=-100; %take out solutions greater than 
    Fsols(1:length(Fsol),i)=sort(Fsol,'descend');
    Fsols(Fsols==-100)=NaN;
    %Fsols=sort(Fsols,'descend');
end
Fsols=log2(Fsols/(r/(p+1)));

plot2=plot(Lrange,Fsols','b','LineWidth',4);
plot2(2).LineStyle='--';

%case 3: logistic growth
E=0;
p=1;
Fsols=ones(3,length(Lrange))*(-100);
for i=1:length(Lrange)
    L=Lrange(i);
    u(F)=((2*F - r)*(F^2 - r*F + a/L))/(F*a*(F - r))+E;
    Fsol=vpasolve(u);
    Fsol(eval(imag(Fsol)~=0))=-100; %take out imaginary solutions
    Fsol(Fsol<0)=-100; %take out negative solutions
    Fsol(Fsol>3)=-100; %take out F>3 solutions
    Fsols(1:length(Fsol),i)=sort(Fsol,'descend');
    Fsols(Fsols==-100)=NaN;
    Fsols=sort(Fsols,'descend');
end
Fsols=log2(Fsols/(r/(p+1)));

plot3=plot(Lrange,Fsols','k','LineWidth',2);
plot3(2).LineStyle='--';

%case 4: logistic growth with both linear cost with harvest volume and
%linear cost with effort (costs proportional to each other)

E=-0.2;
Fsols=ones(3,length(Lrange))*(-100);
for i=1:length(Lrange)
    L=Lrange(i);
    u(F)=(F*L)/a + E*L + (L*(F - r))/a + (V*a*(F/a + (F - r)/a))/(F*(F - r)); %linear cost + effort cost
    Fsol=vpasolve(u);
    Fsol(eval(imag(Fsol)~=0))=-100; %take out imaginary solutions
    Fsol(Fsol<0)=-100; %take out negative solutions
    Fsol(Fsol>3)=-100; %take out F>3 solutions
    Fsols(1:length(Fsol),i)=sort(Fsol,'descend');
    Fsols(Fsols==-100)=NaN;
    Fsols=sort(Fsols,'descend');
end
Fsols=log2(Fsols/(r/(p+1)));

plot4=plot(Lrange,Fsols','m','LineWidth',4);
plot4(2).LineStyle='--';